{% extends "front/base_logged.html" %}
{% load i18n %}
{% load static %}
{% load render_table from django_tables2 %}

{% block content %}

    {% include "wizard/header.html" %}

    <div class="panel panel-default">
      <div class="panel-heading">
          <strong>{% trans "Definir Estações" %}</strong>
          <div class="help">
              <button id="help_btn" type="button" class="btn btn-primary btn-xs" data-toggle="tooltip" data-placement="top" title="{% trans 'Mais info' %}" data-title="{% trans 'Mais info' %}" data-title_alt="{% trans 'Menos info' %}">
                  <span class="glyphicon glyphicon-question-sign"></span>
              </button>
              <button id="tips_btn" type="button" class="btn btn-primary btn-xs" data-toggle="tooltip" data-placement="top" title="{% trans 'Dicas' %}">
                  <span class="glyphicon glyphicon-info-sign"></span>
              </button>
          </div>
      </div>
      <div id="help" class="alert alert-warning cst_hide">
          {% include "wizard/help_text/step_stations.html" %}
      </div>
      <div class="panel-body">
          {% blocktrans trimmed %}
            Neste passo o utilizador define as estações (sensores virtuais) nas quais pretende obter séries temporais de previsão com a total resolução do modelo.
          Estas poderão ser locais onde existam dados em tempo real, estações pré-identificadas (estações de comparação) ou outros locais de interesse (estações virtuais).
          {% endblocktrans %}
      </div>
    </div>

    {% if errors %}
    <div class="alert alert-danger">
        <ul>
            {% for error in errors %}
            <li>{{ error }}</li>
            {% endfor %}
        </ul>
    </div>
    {% endif %}

    <div class="row nopad">
        <h5><strong>{% trans 'Marque/desmarque as estações que pretende usar. Pode adicionar novas estações marcando uma localização no mapa ou com o botão Nova Estação.' %}</strong>
            <br/>{% trans 'Nota: se a lista estiver vazia à partida isso significa que não existem estações de observação localizadas dentro do domínio da malha.' %}
        </h5>
    </div>

    <div class="row nopad resizableCols">
        <div class="col1">
            {% if stations_table %}
            {% render_table stations_table %}
            {% endif %}

            <button id="btn_define" class="btn btn-primary btn-sm"><strong>{% trans "Nova Estação" %}</strong></button>
        </div>
        <div class="col2">
            {% include "wizard/map.html" %}
        </div>
    </div>

    <form id="station_form" class="form" method="post">{% csrf_token %}
        {% include "wizard/modal/stationnew.html" %}

        <div class="row btnmenu" style="margin-top: 10px;">
            <div class="col-xs-8">
                <button id="btn_prev" type="button" class="btn btn-default" data-step="10" data-intro="{% trans 'Pode sempre revisitar passos anteriores' %}">
                    <span class="glyphicon glyphicon-arrow-left"></span> {% trans "Anterior" %}
                </button>
                <button id="btn_restart" class="btn btn-default" data-step="10" data-intro="{% trans 'ou limpe e recomeçe o passo' %}" data-toggle="tooltip" data-placement="top" title="{% trans 'Reset do passo e apaga passos posteriores' %}">{% trans "Recomeçar passo" %}</button>
            </div>
            <div class="col-xs-4 text-right">
                {% if request.session.last_step < step %}
                <button id="btn_submit" type="submit" name="next" class="btn btn-primary" data-step="9" data-intro="{% trans 'Prima o botão' %}">
                    {% trans "Concluir passo" %} <span class="glyphicon glyphicon-arrow-right"></span>
                </button>
                {% else %}
                <button id="btn_submit" type="submit" name="edit" class="btn btn-primary" data-toggle="tooltip" data-placement="top" title="{% trans 'Aplicar alterações efetuadas ao passo' %}" data-step="8" data-intro="{% trans 'Se efetuar alterações ao passo prima este botão para as guardar' %}">
                    {% trans "Guardar alterações" %}
                </button>
                <button id="btn_next" class="btn btn-default" data-step="12" data-intro="{% trans 'Ou passos posteriores' %}">
                    {% trans "Seguinte" %} <span class="glyphicon glyphicon-arrow-right"></span>
                </button>
                {% endif %}
            </div>
        </div>
    </form>

    <!-- Load some extra resources -->
    <link rel="stylesheet" href="{% static 'vendor/jquery/jquery-ui-1.12.1.min.css' %}">
    <script src="{% static 'vendor/jquery/jquery-ui-1.12.1.min.js' %}"></script>

    <script type="text/javascript">
        // Global variables
        var max_stations = {{ max_stations|default:5 }};    // max number of allowed checked stations
        var rec_distance = {{ rec_distance|default:100 }};  // recommended distance between comparision stations

        $('#btn_apply').click(function(e){
            e.preventDefault();

            // Clear errors
            $("#form_errors").hide();
            $('#form_errors').html('');

            var flag = true;
            var msg = '{% trans "Para continuar terá de preencher os campos obrigatórios (*)." %}';

            var name = $("input[name='name']").val();
            var lat = parseFloat($("input[name='lat']").val());
            var lon = parseFloat($("input[name='lon']").val());
            var cstation_val = $("select[name='cstation'] option:selected").val();
            var cstation = $("select[name='cstation'] option:selected").text();
            var stype = $("input[name='stype']:checked").val();

            // Name, coordinates and comparison station if stype = 'C' are mandatory
            if (name == '' || Number.isNaN(lat) || Number.isNaN(lon) ) {
                flag = false;
            } else if (stype == 'C' && cstation_val == '') {
                msg = '{% trans "Para continuar terá de selecionar uma estação de comparação." %}';
                flag = false;
            }

            // Show error
            if (!flag) {
                $('#form_errors').html(msg);
                $("#form_errors").show();
            } else {
                // Add some animation
                var btn = $(this);
                var btnlbl = btn.html().replace('<span class="glyphicon glyphicon-repeat spin"></span> ', '');
                btn.html('<span class="glyphicon glyphicon-repeat spin"></span> ' + btnlbl);

                // Disable buttons to prevent multiple calls
                btn.attr('disabled', '');
                btn.prev().attr('disabled', '');

                // Set some timeout to allow changes to buttons above to render
                setTimeout( function() {
                    // Validate if coordinates inside BBox polygon
                    var point = new L.LatLng(lat, lon);
                    var pointIN = insideBBox(point);

                    // Reset form
                    btn.html(btnlbl);
                    btn.removeAttr('disabled');
                    btn.prev().removeAttr('disabled');

                    if (!pointIN) {
                        var msg = '{% trans "A nova estação tem de estar posicionada dentro da malha!" %}';
                        $('#form_errors').html(msg);
                        $("#form_errors").show();
                    } else {
                        // Validate if coordinate already exists in table and if not too close to others
                        var pointOK = validPoint($("#sid").val(), lat, lon);
                        if (pointOK > 0) {
                            if (pointOK == 1) {
                                var msg = '{% trans "Já existe uma estação nova nessa coordenada!" %}';
                            } else {
                                var msg = '{% trans "Já existe uma estação nova demasiado próxima dessa coordenada!" %}';
                            }

                            $('#form_errors').html(msg);
                            $("#form_errors").show();
                        } else {
                            // All is good - set station
                            setStation(name, lat, lon, stype, cstation);
                            // Reset form
                            $('#station_form')[0].reset();
                            // Hide modal form
                            $('#divModal_station').modal('hide');
                        }
                    }
                }, 10);
            }
        });

        // Hover Station table row - highlight feature
        $('#stations_table tbody tr').hover(function(e) {
            setHighlight(e);
          }, function(e) {
            resetHighlight(e);
          }
        );

        // Click Station table row
        $('#stations_table tbody tr').click(function(e) {
            rowClick(e.currentTarget, name);
        });

        $('#btn_define').click(function(e){
            if (!stationsMaxLimit()) {
                // Change Form's Title
                $('#formLabel').html('{% trans "Nova Estação" %}');
                $('#applyLabel').html('{% trans "Adicionar" %}');
                $("#sid").val(null);

                // Reset form before opening modal form
                clearForm();

                $('#divModal_station').modal('show');
            } else {
                $('#msg_str').html('{% trans "Atingiu o limite máximo de estações que pode usar num modelo " %} ('+ max_stations + ').');
                $('#divModal_msg').modal('show');
            }
        });

        $("select[name='cstation']").change(function(e) {
            // Show message if distance between new position and selected comparison station is higher than recommended
            var lat = parseFloat($("input[name='lat']").val());
            var lon = parseFloat($("input[name='lon']").val());

            // Read comparison station coordinates
            var cstation = $("select[name='cstation'] option:selected").text();
            var clat = parseFloat(cstation.substring(cstation.indexOf('(')+1, cstation.indexOf(',')));
            var clon = parseFloat(cstation.substring(cstation.indexOf(',')+2, cstation.indexOf(')')));

            var distance = getDistance([lat, lon], [clat, clon]);
            if (distance > rec_distance) {
                var msg = '{% trans "Nota: esta estação encontra-se a "%}' +
                    distance + 'm. ' + '{% trans "A distância máxima recomendada é de " %}' + rec_distance + 'm.';
                $(e.currentTarget).parent().find('h5').html(msg);
            } else {
                $(e.currentTarget).parent().find('h5').html('');
            }
        });

        // Button Order Stations
        $('#btn_order').click(function(e){
            e.preventDefault();

            var fieldlat = $("input[name='lat']");
            var fieldlon = $("input[name='lon']");

            if (fieldlat[0].validity.valid && fieldlon[0].validity.valid && fieldlat.val() != '' && fieldlon.val() != '') {
                var lat = parseFloat($("input[name='lat']").val());
                var lon = parseFloat($("input[name='lon']").val());
                sortStations("select[name='cstation']", lat, lon);
                $(e.currentTarget).parent().find('h5').html('{% trans "Lista ordenada com sucesso." %}');
            } else {
                $(e.currentTarget).parent().find('h5').html('{% trans "Para ordenar por distância terá de inserir coordenadas válidas." %}');
            }
        });

        // Submit Step event
        $('#btn_submit').click(function(e){
            var flagok = true;
            var msg = '';

            try {
                // Build chosen stations array
                var stations = [];
                $('#stations_table tbody tr').each(function(i, obj){
                    var sid = obj.cells[0].children[0].getAttribute('data-code');
                    var stype = obj.cells[0].children[0].getAttribute('data-type');
                    var chk = obj.cells[0].children[0];
                    var name = obj.cells[1].innerText;
                    var lat = obj.cells[2].innerText;
                    var lon = obj.cells[3].innerText;
                    var cstation = obj.cells[4].innerText;

                    // for each row build deploy station dict
                    var chk_val = (chk.checked) ? 1 : 0;
                    var sdict = {'chk': chk_val, 'code': sid, 'type': stype, 'name': name, 'lat': lat, 'lon': lon, 'cstation': cstation};

                    // Pass more info if type = 'C'
                    if (stype == 'C') {
                        var oid = getSID(cstation);
                        var obsfeature = map._layers[oid].feature;

                        sdict['source'] = obsfeature.properties.source;
                        sdict['owner'] = obsfeature.properties.owner;
                        sdict['params'] = obsfeature.properties.params;
                    }
                    stations.push(sdict);
                });

                $('#divModal_processing').modal('show');

                $('#id_stations').val(JSON.stringify(stations));

                var btnname = e.currentTarget.name;
                if (btnname == 'edit') {
                    e.preventDefault();
                    // Send form data via client-side
                    $.ajax({
                        type: 'POST',
                        url: '{% url 'wizard:save_steps' step=0 %}'.replace(/0/, step),
                        data: $('.form').serialize(),
                        success: function(data) {
                            $('#divModal_processing').modal('hide');

                            if (data['msg']) {
                                $('#msg_str').html(data['msg']);
                                $('#divModal_msg').modal('show');
                            }
                        },
                        error: function(e, x, r) {
                            console.log(r + ' - ' + e);
                            $('#divModal_processing').modal('hide');

                            $('#msg_str').html('{% trans "Ocorreu um erro! Por favor tente mais tarde." %}');
                            $('#divModal_msg').modal('show');
                        }
                    });
                }
            } catch(err) {
                e.preventDefault();
                console.log(err);
                $('#divModal_processing').modal('hide');

                $('#msg_str').html('{% trans "Ocorreu um erro! Por favor tente mais tarde." %}');
                $('#divModal_msg').modal('show');
            }
        });

        var sortStations = function (select, lat, lon) {
            // Sort stations by distance to point ASC
            $(select).html($(select).children('option').sort(function (a, b) {
                var cstation1 = a.text;
                var cstation2 = b.text;

                if (cstation1 == '-----') return -1;

                var clat1 = parseFloat(cstation1.substring(cstation1.indexOf('(')+1, cstation1.indexOf(',')));
                var clon1 = parseFloat(cstation1.substring(cstation1.indexOf(',')+2, cstation1.indexOf(')')));

                var clat2 = parseFloat(cstation2.substring(cstation2.indexOf('(')+1, cstation2.indexOf(',')));
                var clon2 = parseFloat(cstation2.substring(cstation2.indexOf(',')+2, cstation2.indexOf(')')));

                var distance1 = getDistance([lat, lon], [clat1, clon1]);
                var distance2 = getDistance([lat, lon], [clat2, clon2]);

                return distance1 < distance2 ? -1 : 1;
            }));
            $(select).get(0).selectedIndex = 0;
        };

        var sortSelect = function (select) {
            // Sort select alphabetically ASC
            $(select).html($(select).children('option').sort(function (x, y) {
                return $(x).text().toUpperCase() < $(y).text().toUpperCase() ? -1 : 1;
            }));
            $(select).get(0).selectedIndex = 0;
        };

        function getSID(text) {
            var val = null;
            $("select[name='cstation'] option").each(function(i) {
                if ($(this).text() == text) {
                     val = $(this).val();
                     return false;
                }
            });
            return val;
        }

        function getDistance(origin, destination) {
            // return distance in meters
            var lon1 = toRadian(origin[1]),
                lat1 = toRadian(origin[0]),
                lon2 = toRadian(destination[1]),
                lat2 = toRadian(destination[0]);

            var deltaLat = lat2 - lat1;
            var deltaLon = lon2 - lon1;

            var a = Math.pow(Math.sin(deltaLat/2), 2) + Math.cos(lat1) * Math.cos(lat2) * Math.pow(Math.sin(deltaLon/2), 2);
            var c = 2 * Math.asin(Math.sqrt(a));
            var EARTH_RADIUS = 6371;
            return Math.round(c * EARTH_RADIUS * 1000);
        }

        function toRadian(degree) {
            // Degree to radian
            return degree*Math.PI/180;
        }

        function stationsMaxLimit() {
            // Max stations reached?
            var selstations = $('.selSID:checked');
            if (selstations.length >= max_stations) {
                return true;
            }
            return false;
        }

        function validPoint(id, lat, lon) {
            // Validate new station's coordinates - can't exist already in table or be too close
            var error = 0, precision = 3;
            $('#stations_table tbody tr').each(function(i, currow) {
                var sid = currow.cells[0].children[0].getAttribute('data-code');
                var cur_lat = parseFloat(currow.cells[2].innerText);
                var cur_lon = parseFloat(currow.cells[3].innerText);
                if (id != sid) {
                    // Same coordinate position or too close?
                    if (cur_lat == lat && cur_lon == lon) {
                        error = 1;
                        return;
                    } else if (cur_lat.toFixed(precision) == lat.toFixed(precision) && cur_lon.toFixed(precision) == lon.toFixed(precision)) {
                        error = 2;
                        return;
                    }
                }
            });
            return error;
        }

        function addStation(layer_id) {
            var feature = map._layers[layer_id].feature;
            var name = feature.properties.name;
            var lat = feature.geometry.coordinates[1];
            var lon = feature.geometry.coordinates[0];
            var cstation = name + ' (' + lat + ', ' + lon + ')';
            // Clear sid - new point
            $("#sid").val(null);

            // Add station
            setStation(name, lat, lon, 'C', cstation);
        }

        function removeStation(layer_id) {
            // Remove corresponding line in table
            $('[data-code=' + layer_id + ']').parent().parent().remove();
            var layer = pointsGroup.getLayer(layer_id);   // map._layers[layer_id]; (method used if marker cluster)
            // Remove point in map
            pointsGroup.removeLayer(layer);
            // Remove connecting line if exists
            var connectline = linesGroup.getLayer(layer_id.replace('C', 'L'));
            if (connectline) linesGroup.removeLayer(connectline);
        }

        function setStation(name, lat, lon, stype, cstation) {
            // Default circle settings
            var fillColor = '#333', rad = 5, fillOpacity = 0.8, border = 2, dashArray = null;
            // Get obs station if needed
            var oid = null, obsfeature = null;
            if (stype == 'C') {
                oid = getSID(cstation);
                obsfeature = map._layers[oid].feature;

                // Increase comparision station radius to overlay observation station
                rad = 10;
            }

            var layer_id = $("#sid").val();
            if (layer_id) {
                var selrow = null;
                // Edit row cell
                $('#stations_table tbody tr').each(function(i, currow) {
                    var chk = currow.cells[0].children[0];
                    var row_sid = chk.getAttribute('data-code');
                    if (!chk.checked) dashArray = '5,5';  // checkbox is not selected so render dashed point if created
                    if (layer_id == row_sid) {
                        currow.cells[1].innerText = name;
                        currow.cells[2].innerText = parseFloat(lat);
                        currow.cells[3].innerText = parseFloat(lon);
                        currow.cells[4].innerText = cstation;
                        selrow = currow;
                        return;
                    }
                });

                // Get layer being edited
                var layer = map._layers[layer_id];
                if (layer) {
                    // Build popup window content
                    var popupCtn = buildPopup(layer_id, stype, name, cstation, obsfeature);

                    // Update popup content
                    layer._popup.setContent(popupCtn);

                    // Update station name
                    layer.feature.properties.name = name;

                    // If no changes in coordinates - no need to continue
                    if (layer._latlng.lat == lat && layer._latlng.lng == lon) return;

                    // If coordinates changed remove station from cluster and add new one
                    pointsGroup.removeLayer(layer);
                } else {
                    return;
                }
            }

            // Get legend color
            stationTypes.forEach(function(item) {
                if (item['type'] == stype) {
                    fillColor = item['color'];
                    return true;
                }
            });

            // Add point to map
            var point = new L.LatLng(lat, lon);
            var pointMarkerOptions = {radius: rad, fillColor: fillColor, color: "#333", weight: border, opacity: fillOpacity, fillOpacity: fillOpacity, dashArray: dashArray, riseOnHover: true};
            var pointMarker = L.circleMarker(point, pointMarkerOptions);

            // Generate unique id for layer (if comparision station save in new_id the observation station id)
            var layers = map._layers;
            var counter = 1;
            if (stype == 'C') {
                var test_id = stype + '_' + oid.replace('O_', '') + '_' + counter;
            } else {
                var test_id = stype + '_' + counter;
            }
            // Loop until new leaflet layer id is found
            while (layers[test_id] != undefined) {
                counter += 1;
                if (stype == 'C') {
                    var test_id = stype + '_' + oid.replace('O_', '') + '_' + counter;
                } else {
                    var test_id = stype + '_' + counter;
                }
            }
            var new_sid = test_id;

            pointMarker._leaflet_id = new_sid;
            pointMarker.properties = { 'name': name };

            if (stype == 'C') {
                // If comparison station has different coordinate position create connecting line
                var cstation_coords = obsfeature.geometry.coordinates;
                if (cstation_coords[1] != lat || cstation_coords[0] != lon) createLine([lat, lon], [cstation_coords[1], cstation_coords[0]], new_sid.replace('C', 'L'));
            }

            // Build popup window content
            var popupCtn = buildPopup(new_sid, stype, name, cstation, obsfeature);

            pointMarker.bindPopup(popupCtn);
            pointMarker.on({
              mouseover: highlightStation,
              mouseout: resetStation,
            });

            pointsGroup.addLayer(pointMarker);

            if (layer_id) {
                selrow.cells[0].children[0].setAttribute('data-code', new_sid);
            } else {
                // Add row to table
                var strcnt = '<td class="chk"><input class="selSID" type="checkbox" data-code="' + new_sid + '" data-type="' + stype + '"checked onclick="event.stopPropagation();" onchange="toggleMarkers(this);" /></td>';
                strcnt += '<td class="name">' + name + '</td>';
                strcnt += '<td class="lat">' + parseFloat(lat) + '</td>';
                strcnt += '<td class="lon">' + parseFloat(lon) + '</td>';
                if (stype == 'C') {
                    strcnt += '<td class="cstation">' + cstation + '</td>';
                } else {
                    strcnt += '<td class="cstation"></td>';
                }

                var row = $('<tr class="odd" onclick="rowClick(this);"></tr>');
                row.html(strcnt);
                row.hover(function(e) {
                    setHighlight(e);
                  }, function(e) {
                    resetHighlight(e);
                  }
                );

                $('#stations_table > tbody').append(row);
                map.closePopup();
            }
        }

        function clearForm() {
            // Clear form
            $('#station_form')[0].reset();
            toggleFields();
            // Clear input notes
            $('#station_form h5').html('');
            sortSelect("select[name='cstation']");
        }

        function rowClick(row) {
            // Zoom to map feature
            var lat = row.cells[2].innerText;
            var lon = row.cells[3].innerText;
            // set the view
            map.setView([lat, lon], 16);

            /* NOT SURE IF WE WANT THIS FUNCTIONALITY
            // Open form with row values to edit
            clearForm();

            var sid = row.cells[0].children[0].getAttribute('data-code');
            var stype = row.cells[0].children[0].getAttribute('data-type');

            var name = row.cells[1].innerText;
            // Change Form's labels
            $('#formLabel').html("{% trans 'Estação' %} '" +  name + "'");
            $('#applyLabel').html("{% trans 'Alterar' %}");

            // fill form
            $("#sid").val(sid);
            $("input[name='name']").val(name);
            $("input[name='lat']").val(row.cells[2].innerText);
            $("input[name='lon']").val(row.cells[3].innerText);
            $("input[name='stype'][value='" + stype + "']").prop('checked', true);
            $("select[name='cstation'] option").each(function(){
                if (this.text == row.cells[4].innerText) {
                    $("select[name='cstation']").val(this.value);
                    return;
                }
            });

            toggleFields();

            // open form
            $('#divModal_station').modal('show');
            */
        }

        // Toggle Comparison Form fields
        function toggleFields() {
            $("#form_errors").hide();
            $('#form_errors').html('');

            $("input[name='stype']:checked").blur();
            var stype = $(".form input[name='stype']:checked").val();
            if (stype == 'V') {
                disable_comparision_inputs(true);
            } else {
                disable_comparision_inputs(false);
            }
        }

        // Enable / disable comparision inputs
        function disable_comparision_inputs(disable) {
            $(".grp_C").each(function(){
                if (disable) {
                    $(this).attr('disabled', 'disabled');
                } else {
                    $(this).removeAttr('disabled');
                }
            });
        }

        function toggleMarkers(e) {
            var selstations = $('.selSID:checked');
            if (e.checked) {
                var stype = e.getAttribute('data-type');
                //if (selstations.length <= max_stations || stype == 'C') { // allow all comparision stations
                // Check only if station's max limit not reached
                if (selstations.length <= max_stations) {
                    // Hide/unhide marker
                    var layer_id = e.getAttribute('data-code');
                    var layer = map._layers[layer_id];
                    if (e.checked) {
                        layer.options.dashArray = null;
                    } else {
                        layer.options.dashArray = '5,5';
                    }
                    // pointsGroup.refreshClusters(); // markers cluster not in use
                } else {
                    e.checked = false;
                    $('#msg_str').html('{% trans "Atingiu o limite máximo de estações que pode usar num modelo " %} ('+ max_stations + ').');
                    $('#divModal_msg').modal('show');
                }
            } else {
                var layer_id = e.getAttribute('data-code');
                var layer = map._layers[layer_id];
                layer.options.dashArray = '5,5';
            }
        }

        function setHighlight(e) {
            var sid = e.currentTarget.cells[0].children[0].getAttribute('data-code');
            var layer = map._layers[sid];
            if (layer) {
                layer.setStyle({
                  weight: 4,
                });
            }
        }

        function resetHighlight(e) {
            var sid = e.currentTarget.cells[0].children[0].getAttribute('data-code');
            var layer = map._layers[sid];
            if (layer) {
              layer.setStyle({
                weight: 2,
              });
            }
        }

        // Tooltips Setup (for Intro.js)
        $('#stations_table').attr("data-step", 5);
        $('#stations_table').attr("data-intro", "{% trans 'As estações selecionadas na lista serão usadas para obter séries temporais' %}");

        $('.col2').attr("data-step", 6);
        $('.col2').attr("data-intro", "{% trans 'Pode adicionar novas estações localizadas dentro da malha clickando a sua posição no mapa e preenchendo o formulário' %}");

        $('#btn_define').attr("data-step", 7);
        $('#btn_define').attr("data-intro", "{% trans 'Ou premindo o botão Nova estação e preenchendo o formulário' %}");

        $('#map').attr("data-step", 8);
        $('#map').attr("data-intro", "{% trans 'Pode remover estações da lista premindo sobre elas no mapa e no botão Remover' %}");

        // On Document Ready
        $(function(){
            // Hide error panel
            $('#form_errors').hide();

            // Set Table as resizable
            $(".resizableCols .col1").resizable({
                handles: 'e',
                minWidth: 300,
                maxWidth: 600,
                resize: function() {
                  $('.col1').css('width', $('.col1').outerWidth() * 100 / $('.col1').parent().innerWidth() + '%');
                  $('.col2').css('width', 100 - ($('.col1').outerWidth() * 100 / $('.col1').parent().innerWidth()) + '%');
                  map.invalidateSize(false);
                }
            });

            // Finally create connecting lines between comparison stations and observation stations if they have different coordinates
            // and if they have changed position meanwhile (dashed)
            $('#stations_table tbody tr').each(function(i, obj){
                var sid = obj.cells[0].children[0].getAttribute('data-code');
                var stype = obj.cells[0].children[0].getAttribute('data-type');
                if (stype == 'C') {
                    var dashed = false, a = null, b = null;
                    // Get station coordinates
                    var lat = obj.cells[2].innerText;
                    var lon = obj.cells[3].innerText;
                    // Get observation station coordinates at the time
                    var cstation = obj.cells[4].innerText;
                    var clat = parseFloat(cstation.substring(cstation.indexOf('(')+1, cstation.indexOf(',')));
                    var clon = parseFloat(cstation.substring(cstation.indexOf(',')+2, cstation.indexOf(')')));
                    // Get current observation station coordinates
                    var obspoint = pointsGroup.getLayer(sid.replace('C', 'O'));

                    if (clat != lat || clon != lon) {
                        if (obspoint) {
                            // If current position has changed also create line but a dashed one
                            if (clat != cclat || clon != cclon) {
                                dashed = true;
                                a = [clat, clon];
                                b = [cclat, cclon];
                            } else {
                                dashed = false;
                                a = [lat, lon];
                                b = [clat, clon]
                            }
                        } else {
                            // Station no longer exists
                            dashed = true;
                            a = [lat, lon];
                            b = [clat, clon]
                        }
                        createLine(a, b, sid.replace('C', 'L'), dashed);
                    } else {
                        if (obspoint) {
                            var cclat = obspoint.getLatLng().lat;
                            var cclon = obspoint.getLatLng().lng;

                            // If current position has changed also create line but a dashed one
                            if (clat != cclat || clon != cclon) {
                                dashed = true;
                                createLine([clat, clon], [cclat, cclon], sid.replace('C', 'L'), dashed);
                            }
                        }
                    }
                }
            });
        });
    </script>

{% endblock content %}